<?php
/*
  Template Name: Blog Page
 */
get_header();
?>
<div class="clear"></div>
<div class="page_head">
<h1 class="single-heading"><?php _e( 'Blog Page', 'andrina-lite' ); ?></h1>
</div>
<div class="page-content">
   
	<div class="row">
		<div class="col-md-8 col-sm-8">
			<div class="content-bar">
				<?php
				$paged = (get_query_var( 'paged' )) ? get_query_var( 'paged' ) : 1;
				// WP_Query arguments
				$args = array(
					'post_type' => array( 'post' ),
					'post_status' => array( 'publish' ),
					'paged' => $paged,
					'is_archive' => true,
					'is_home' => false
				);
// The Query
				$wp_query = new WP_Query( $args );
// The Loop
				if ( $wp_query->have_posts() ):
					while ( $wp_query->have_posts() ) {
						$wp_query->the_post();
						get_template_part( 'templates/content' );
					}
				else:
					?>
					<div class="post">
						<p>
							<?php _e( 'Sorry, no posts matched your criteria.', 'andrina-lite' ); ?>
						</p>
					</div>
				<?php endif; ?>
				<!--End Loop-->
				<div class="clear"></div>
				<?php andrina_pagination(); ?> 
			</div>
		</div>

		<div class="col-md-4 col-sm-4">
			<!--Start Sidebar-->
			<?php get_sidebar(); ?>
			<!--End Sidebar-->
		</div>
	</div>
</div>

<?php
get_footer();
