<?php

function andrina_gallery_image_css() {
    wp_enqueue_style('andrina-galleryimagewidget', ANDRINA_DIR_URI . "includes/widgets/gallery-image-widget/css/gallery-image-widget.css", '', '', 'all');
}

add_action('wp_enqueue_scripts', 'andrina_gallery_image_css');

class andrina_gallery_widget extends WP_Widget {

    /**
     * Sets up the widgets name etc
     */
    public function __construct() {
        $widget_ops = array(
            'classname' => 'andrina_gallery_widget',
            'description' => __('Gallery Widget can be used a portion of gallery in any widget area','andrina-lite'),
        );
        parent::__construct('Smart_gallery_widget', __('Smart Gallery Widget','andrina-lite'), $widget_ops);
    }

    /**
     * Outputs the content of the widget
     *
     * @param array $args
     * @param array $instance
     */
    public function widget($args, $instance) {
        echo $args['before_widget'];
        if (!empty($instance['title'])) {
            echo $args['before_title'] . apply_filters('widget_title', $instance['title']) . $args['after_title'];
        }

        $_max = $instance['numb_post'];
//        $_max = 9;
//        $r = new WP_Query("showposts=$_max&what_to_show=posts&post_status=inherit&post_type=attachment&orderby=menu_order ASC, ID ASC&post_mime_type=image/jpeg,image/gif,image/jpg,image/png");
        $attachment_args = array(
            'post_type' => 'attachment',
            'numberposts' => -1,
            'showposts' => $_max,
            'post_status' => null,
            'orderby' => 'menu_order ID'
        );
        $attachments = get_posts($attachment_args);
        if ($attachments) {
            echo '<ul class="gallery_attachment_widget">';
            foreach ($attachments as $gallery_image) {
                $attachment_img = wp_get_attachment_url($gallery_image->ID);
                $img_source = andrina_image_resize($attachment_img, 82, 82);
                echo ' <div class="gallery_entry">
			<div class="item_image"><li><a alt="' . $gallery_image->post_title . '" href="' . $attachment_img . '" rel="prettyPhoto[gallery2]"> <span class="overlay">';
                echo '<img class="portfolio" src="' . $img_source['url'] . '" alt=""$img_source[url]"/>';
                echo '</div></div></li></a></span>';
            }
            echo '</ul>';
        }
        echo $args['after_widget'];
    }

    /**
     * Outputs the options form on admin
     *
     * @param array $instance The widget options
     */
    public function form($instance) {
        // outputs the options form on admin
        $title = !empty($instance['title']) ? $instance['title'] : __('Gallery', 'andrina-lite');
        $numb_post = !empty($instance['numb_post']) ? $instance['numb_post'] : 9;
        ?>
        <p>
            <label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:','andrina-lite'); ?></label> 
            <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>">
            <label for="<?php echo $this->get_field_id('numb_post'); ?>"><?php _e('Number Of Post:','andrina-lite'); ?></label>
            <input class="widefat" id="<?php echo $this->get_field_id('numb_post'); ?>" name="<?php echo $this->get_field_name('numb_post'); ?>" type="text" value="<?php echo esc_attr($numb_post); ?>">
        </p>
        <?php
    }

    /**
     * Processing widget options on save
     *
     * @param array $new_instance The new options
     * @param array $old_instance The previous options
     */
    public function update($new_instance, $old_instance) {
        // processes widget options to be saved
        $instance = array();
        $instance['title'] = (!empty($new_instance['title']) ) ? strip_tags($new_instance['title']) : '';
        $instance['numb_post'] = (!empty($new_instance['numb_post']) ) ? strip_tags($new_instance['numb_post']) : '9';
        return $instance;
    }

}

/**
 * Register widget on init
 *
 * @since 1.0
 */
function andrina_register_gallery_widget() {
    register_widget('andrina_gallery_widget');
}

add_action('widgets_init', 'andrina_register_gallery_widget', 1);
?>
